package org.netkernel.mod.architecture;

import java.util.Comparator;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IHDSNodeList;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.layer0.representation.impl.HDSNodeListImpl;

import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class ControlPanelConfig extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		HDSBuilder b=new HDSBuilder();
		b.pushNode("controlpanel");
		
		
		b.pushNode("icon");
		b.addNode("title","Space Explorer");
		b.addNode("subtitle","Explore the structure of modules and their spaces");
		b.addNode("path","/panel/urn:org:netkernel:nkse:control:panel:explorer");
		b.addNode("icon","/tools/ae/pub/icon.png");
		b.addNode("panel","urn:org:netkernel:nkse:control:panel:developer");
		b.addNode("order","10");
		b.popNode();
		
		b.pushNode("panel");
		b.addNode("id","urn:org:netkernel:nkse:control:panel:explorer");
		b.addNode("shorttitle","Explore");
		b.addNode("title","Space Explorer");
		b.addNode("subtitle","Explore the structure of modules and their spaces");
		b.addNode("icon","/tools/ae/pub/icon.png");
		b.addNode("order","5");
		b.popNode();
		
		b.pushNode("icon");
		b.addNode("title","Space Explorer");
		b.addNode("subtitle","Explore the structure of modules and their spaces");
		b.addNode("path","/tools/ae/");
		b.addNode("icon","/tools/ae/pub/icon.png");
		b.addNode("panel","urn:org:netkernel:nkse:control:panel:explorer");
		b.addNode("order","-1");
		b.popNode();

		try
		{
			ISERep config = aContext.source("active:seConfig",ISERep.class);
			IHDSNodeList rootViews=config.getViewsFor("root");
			rootViews.sort(new Comparator<IHDSNode>()
			{	public int compare(IHDSNode arg0, IHDSNode arg1)
				{	Object o1=arg0.getFirstValue("order");
					Object o2=arg1.getFirstValue("order");
					int or1=(o1!=null)?Integer.parseInt(o1.toString()):Integer.MAX_VALUE;
					int or2=(o2!=null)?Integer.parseInt(o2.toString()):Integer.MAX_VALUE;
					return or1-or2;
				}
			});
			for (IHDSNode view: rootViews)
			{
				String name=view.getFirstValue("name").toString();
				String id=view.getFirstValue("id").toString();
				b.pushNode("icon");
				b.addNode("panel","urn:org:netkernel:nkse:control:panel:explorer");
				b.addNode("path", "/tools/ae/view/"+id);
				String icon=(String)view.getFirstValue("icon");
				if (icon==null) icon="/tools/ae/pub/icon.png";
				b.addNode("icon",icon);
				b.addNode("title", name);
				b.addNode("subtitle", view.getFirstValue("desc"));
				b.popNode();
					
			}
		}
		catch (Exception e)
		{	System.out.println(e);
		}
		
		
		
		aContext.createResponseFrom(b.getRoot());
		
	}
	
}
