<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xalan="http://xml.apache.org/xalan" xmlns:nk="http://1060.org">
    <xsl:output method="xml"/>
	<xsl:variable name="base">/tools/explore/</xsl:variable>
	<xsl:param name="module" nk:class="java.lang.String"/>
	<xsl:param name="space" nk:class="java.lang.String"/>
	<xsl:param name="filter" nk:class="java.lang.String"/>
	<xsl:variable name="filtertext">
		<xsl:if test="$filter">?filter=<xsl:value-of select="$filter"/></xsl:if>
	</xsl:variable>
	
	<xsl:template match="/">
		
		<div  class="tree-box" >
			<table class="form-table">
				<tr>
				<td><b>Filter:</b></td>
				<td><form action="" method="GET"><input type="text" name="filter" value="{$filter}" title="Filter by substring match"/></form></td>
				<td><form action="" method="GET"><input type="submit"  value="reset" class="btn"/></form></td>
				</tr>
			</table>
			<xsl:choose>
				<xsl:when test="$filter">
					<xsl:apply-templates select="modules/module[contains(id, $filter)]">
						<xsl:sort select="id"/>
					</xsl:apply-templates>
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates select="modules/module">
						<xsl:sort select="id"/>
					</xsl:apply-templates>
				</xsl:otherwise>
			</xsl:choose>
		</div>
	</xsl:template>	

	<xsl:template match="module">
		<xsl:variable name="expand" select="hash=$module"/>
		<div id="j{hash}" >
			<div class="tree-module" >
			<xsl:if test="problem">
				<xsl:attribute name="class">error</xsl:attribute>
			</xsl:if>
			<xsl:if test="hash=$module and string-length($space)=0">
				<xsl:attribute name="class">selected</xsl:attribute>
			</xsl:if>
				<a href="{$base}{hash}{$filtertext}">
					<xsl:value-of select="id"/>
				</a>
			</div>
			<xsl:if test="$expand">
			<div class="indent">
				<xsl:apply-templates select="spaces/space"/>
			</div>
			</xsl:if>
		</div>
	</xsl:template>
	
	<xsl:template match="space">
		<div>
			<!--<img src="/tools/introspect/pub/dot.png" border="0" style="margin-right: 1px;"/>-->
			<div>
				<xsl:if test="problem">
					<xsl:attribute name="class">error</xsl:attribute>
				</xsl:if>
				<xsl:if test="hash=$space">
					<xsl:attribute name="class">selected</xsl:attribute>
				</xsl:if>
				<a href="{$base}{hash}{$filtertext}">
					<xsl:value-of select="name"/>
				</a>
			</div>
			<xsl:if test="spaces/space">
				<div class="indent">
					<xsl:apply-templates select="spaces/space"/>
				</div>
			</xsl:if>
		</div>
	</xsl:template>
			
</xsl:stylesheet>