<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml"/>

	<xsl:param name="params"/>
		
	<xsl:template match="/">
		<div>
				<form method="get" action="">
				
					<table cellpadding="4">
						<tr>
							<td valign="top">
								<table>
									<tr>
										<td class="label">Grammar:</td>
										<td>
											<textarea name="grammar" style="width:500px; height: 200px;">
												<xsl:if test="/results/errors">
													<xsl:attribute name="class">error</xsl:attribute>
												</xsl:if>
												<xsl:choose>
												<xsl:when test="$params and $params/hds/grammar">
													<xsl:value-of select="translate($params/hds/grammar, '&#xA;', '')"/>
												</xsl:when>
												<xsl:otherwise>
													<xsl:text>&lt;grammar&gt;...&lt;/grammar&gt;</xsl:text>
												</xsl:otherwise>
												</xsl:choose>
											</textarea>						
										</td>
									</tr>
									<xsl:if test="/results/errors">
										<tr>
											<td class="label">Errors:</td>
											<td>
												<table class="data-table">
													<tr class="vis-title">
														<td>Message</td><td>Location</td>
													</tr>
													<xsl:for-each select="results/errors/error">
														<tr>
															<td><xsl:value-of select="msg"/></td>
															<td><xsl:value-of select="loc"/></td>
														</tr>
													</xsl:for-each>
												</table>
											</td>
										</tr>
									</xsl:if>
									
									<tr>
										<td class="label">Identifier:</td>
										<td>
											<textarea name="identifier" style="width:500px; height:50px;">
												<xsl:choose>
													<xsl:when test="$params and $params/hds/identifier">
														<xsl:value-of select="$params/hds/identifier"/>
													</xsl:when>
													<xsl:otherwise>...</xsl:otherwise>
												</xsl:choose>
											</textarea>											
										</td>										
									</tr>
									<tr>
										<td/>
										<td valign="top">
											<input type="submit" name="parse" value="Parse Identifier"/>						
										</td>
									</tr>
									<xsl:if test="results/matches">
										<tr>
											<td class="label">Matches:</td>
											<td style="font-size: 150%; font-weight:bold">
												<xsl:choose>
													<xsl:when test="results/matches = 'true'">
														<span style="color:green;">true</span>
													</xsl:when> 
													<xsl:otherwise>
														<span style="color:red;">false</span>
													</xsl:otherwise>
												</xsl:choose>
											</td>
										</tr>
									</xsl:if>
									
									<tr>
										<td class="label">Parts:</td>
										<td>
											<table>
												<tr>
													<td><b>Name</b></td><td><b>Value</b></td>
												</tr>												
												<xsl:for-each select="results/parts/part">
													<tr>
														<td><input type="text" value="{name}" name="n{position()}"/></td>
														<td><input type="text" value="{value}" name="v{position()}"/></td>
													</tr>
												</xsl:for-each>
												<xsl:variable name="n" select="count(results/parts/part)"/>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+1"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+2"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+3"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+4"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+5"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+6"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+7"/></xsl:call-template>
												<xsl:call-template name="part"><xsl:with-param name="p" select="$n+8"/></xsl:call-template>
											</table>
										</td>
									</tr>
									<tr>
										<td/>
										<td valign="top">
											<input type="submit" name="construct" value="Construct Identifier"/>						
										</td>
									</tr>
									<xsl:if test="results/constructed">
										<tr>
											<td valign="top">Constructed:</td>
											<td style="font-size: 150%; font-weight:bold"><xsl:value-of select="results/constructed"/></td>
										</tr>
									</xsl:if>
									<xsl:if test="results/construct-error">
										<tr>
											<td valign="top">Errors:</td>
											<td class="error"><xsl:value-of select="results/construct-error"/></td>
										</tr>
									</xsl:if>
									
									<tr>
										<td colspan="2">
										<xsl:call-template name="cookbook"/>
										</td>
									</tr>					
								</table>
							</td>
							<td valign="top">
								<div class="template-aux-box">
									<input type="button" class="btn" onclick="document.location='/book/view/book:guide:logicalreference/doc:logicalreference:module:standard:logical:grammar'" value="Detailed Documentation"/>
									
									<div style="clear: both;">
									<h2>Grammar Quick Reference</h2>
									<h2>Simple Quick Ref</h2>
									<table>
										<tr>
											<td>root:</td>
											<td>&lt;simple&gt;</td>
										</tr>
									</table>
									<p>
										Simple must start with &lt;simple&gt; and can have any number of <b>{argname}</b>
										argument delimiters mixed in with arbitrary static text. For example...										
									</p>
									<p>
										res:/{country}/{state}/{city}
									</p>
									<h4>Regex Patterns</h4>
									<p>
										Any argument delimiter may also implement an additional regex pattern after a colon (:) seperator
										between the argument name and the regex. For example...
									</p>
									<p>
										res:/{country:(UK|USA|France|Belgium)}/{state}/{city}
									</p>
									<h2>Active Quick Ref</h2>
									<table>
										<tr>
											<td>root:</td>
											<td>&lt;active&gt;</td>
										</tr>
										<tr>
											<td>identifier:</td>
											<td>&lt;identifier&gt;type&lt;/identifier&gt;</td>
										</tr>
										<tr>
											<td>argument:</td>
											<td>&lt;argument name="xxxx" min="x" max="x" /&gt;</td>
										</tr>
										<tr>
											<td>varargs:</td>
											<td>&lt;varargs/&gt;</td>
										</tr>
									</table>
									<p>
										active must start with &lt;active&gt; and can have any number of &lt;identifier&gt; elements
										each of which corresponds with a base for the active URI. Any number of arguments can be 
										specified and order is not significant. &lt;varargs/&gt; indicates any number of unnamed arguments
										may follow and will be parsed as active arguments.
									</p>
									<h2>Standard Grammar Quick Ref</h2>
									<p>
										The Standard Grammar is the most powerful and expressive grammar language.
									</p>
									<table>
										<tr>
											<td>group:</td>
											<td>&lt;group name="xxxx" min="x" max="x" encoding="x"&gt;
													<br/>
												all attributes are optional
												<ul>
													<li>name - identity of grammar part</li>
													<li>min - minimum number of times this must match (default = 1), * indicates unlimited</li>
													<li>max - maximum number of times this must match (default = 1), * indicates unlimited</li>
													<li>encoding - only currently supports: active, url-query, (default is to do no encoding)</li>
												</ul>
											</td>
										</tr>
										<tr>
											<td>regex:</td>
											<td>&lt;regex&gt;regex&lt;/regex&gt;</td>
										</tr>
										<tr>
											<td>interleave:</td>
											<td>&lt;interleave&gt; ... &lt;/interleave&gt; <br/> allows groups to be interleaved in any order</td>
										</tr>
										<tr>
											<td>choice:</td>
											<td>&lt;choice&gt; ... &lt;/choice&gt; <br/> choice of groups</td>
										</tr>
										<tr>
											<td>optional:</td>
											<td>&lt;optional&gt; ... &lt;/optional&gt; <br/> enclosed group is optional</td>
										</tr>
										<tr>
											<td>builtin types:</td>
											<td>&lt;regex type="xxxx" /&gt;
												<br/>
												Where <i>type</i> is optional and can be...
												<ul>
													<li>uri - matches a URI</li>
													<li>active-escaped-uri - strictly matches an Active URI argument</li>
													<li>active-escaped-uri-loose - matches an Active URI argument and is tolerant</li>
													<li>relative-path - matches a URI relative path</li>
													<li>relative-directory-path - matches a relative directory path</li>
													<li>path-segment - matches a single path segment</li>
													<li>integer - matches an integer</li>
													<li>float - matches an float</li>
													<li>nmtoken - BNF nmtoken</li>
													<li>alphanum - matches alphanumeric characters</li>
													<li>anything - matches anything</li>
													<li>nothing - matches nothing</li>
												</ul>
											</td>
										</tr>
									</table>
									<p>
										Standard Grammars must start with a &lt;group&gt; and can intersperse literal text with further groups and regex.
										A group with a name identifies a piece of the parsed identifier.  
									</p>
									
								</div></div>
							</td>
						</tr>
					</table>
				</form>
		</div>
	</xsl:template>
	
	<xsl:template name="part">
		<xsl:param name="p"/>
		<tr>
			<td><input type="text" value="" name="n{$p}"/></td>
			<td><input type="text" value="" name="v{$p}"/></td>
		</tr>
	</xsl:template>
	
	<xsl:template name="cookbook">
		<div>
			<h2>Cookbook</h2>
				<p>
					A selection of example grammars are listed below. Click on a grammar to load it along with a sample identifier.
        </p>
        		<h3>Simple Grammars</h3>
				<ul>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?grammar=<grammar>%0D%0A<simple>res%3A%2F{country}%2F{state}%2F{city}<%2Fsimple>%0D%0A<%2Fgrammar>&identifier=res%3A%2FUK%2FYorkshire%2FBradford&parse=Parse+Identifier&n1=&v1=&n2=&v2=&n3=&v3=&n4=&v4=&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=]]>
						</xsl:attribute>
							Simple REST path style grammar
						</a>
					</li>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?grammar=<grammar>%0D%0A<simple>res%3A%2F{country%3AUK}%2F{state%3A(Yorkshire|Cheshire)}%2F{city}<%2Fsimple>%0D%0A<%2Fgrammar>&identifier=res%3A%2FUK%2FYorkshire%2FBradford&parse=Parse+Identifier&n1=&v1=&n2=&v2=&n3=&v3=&n4=&v4=&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=]]>
						</xsl:attribute>
							Simple REST path with Regex constraints on {country} and {state} arguments
						</a>
					</li>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?grammar=<grammar>%0D%0A<simple>res%3A%2F{country}%2F{state}%2F{city}%3B{matrix}<%2Fsimple>%0D%0A<%2Fgrammar>&identifier=res%3A%2FUK%2FYorkshire%2FBradford%3Bscale%3D100%3Broads%3Dmain&parse=Parse+Identifier&n1=&v1=&n2=&v2=&n3=&v3=&n4=&v4=&n5=&v5=&n6=&v6=&n7=&v7=&n8=&v8=]]>
						</xsl:attribute>
							Simple REST path with an unextracted Matrix URI argument
						</a>
					</li>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?grammar=<grammar>%0D%0A<simple>res%3A%2F{country}%2F{state}%2F{city}%3Bscale%3D{scale}%3Broads%3D{roads}<%2Fsimple>%0D%0A<%2Fgrammar>&identifier=res%3A%2FUK%2FYorkshire%2FBradford%3Bscale%3D100%3Broads%3Dmain&parse=Parse+Identifier&n1=country&v1=UK&n2=state&v2=Yorkshire&n3=city&v3=Bradford&n4=scale&v4=100&n5=main&v5=main&n6=&v6=&n7=&v7=&n8=&v8=&n9=&v9=&n10=&v10=&n11=&v11=&n12=&v12=&n13=&v13=]]>
						</xsl:attribute>
							Simple REST path with extracted Matrix URI arguments
						</a>
					</li>
				</ul>
				<h3>Active Grammars</h3>
				<ul>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?parse=1&identifier=active%3Abase%2Barg%40file%3A%2Fhome%2Fpjr%2Ftest.txt&grammar=<grammar>%0D%0A<active>%0D%0A<identifier>active%3Abase<%2Fidentifier>%0D%0A<argument+name%3D"arg"+min%3D"0"+max%3D"1"%2F>%0D%0A<%2Factive>%0D%0A<%2Fgrammar>]]>
						</xsl:attribute>
							Simple active URI grammar
						</a>
					</li>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?parse=1&identifier=active%3Abase%2Barg1%40file%3A%2Fhome%2Fpjr%2Ftest.txt%2Barg2%40http%3A%2F%2Fnetkernel.org&grammar=<grammar>%0D%0A<active>%0D%0A<identifier>active%3Abase<%2Fidentifier>%0D%0A<argument+name%3D"arg1"+min%3D"0"+max%3D"1"%2F>%0D%0A<argument+name%3D"arg2"+min%3D"0"+max%3D"1"%2F>%0D%0A<%2Factive>%0D%0A<%2Fgrammar>]]>
						</xsl:attribute>
							Simple active URI grammar (two arguments)
						</a>
					</li>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?parse=1&identifier=active%3Aservice%2Boperator%40res%3A%2Fmyscript%2Boperand%40res%3A%2Fmyresource&grammar=<grammar>%0D%0A<active>%0D%0A<identifier>active%3Aservice<%2Fidentifier>%0D%0A<argument+name%3D"operator"+min%3D"0"+max%3D"1"%2F>%0D%0A<argument+name%3D"operand"+min%3D"0"+max%3D"1"%2F>%0D%0A<%2Factive>%0D%0A<%2Fgrammar>]]>
						</xsl:attribute>
							Active URI grammar for the operand/operator convention
						</a>
					</li>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?parse=1&identifier=active%3AserviceSomething%2Boperator%40res%3A%2Fmyscript%2Boperand%40res%3A%2Fmyresource&grammar=<grammar>%0D%0A<active>%0D%0A<identifier>active%3AserviceSomething<%2Fidentifier>%0D%0A<identifier>active%3AserviceSomethingElse<%2Fidentifier>%0D%0A<identifier>active%3AserviceAnother<%2Fidentifier>%0D%0A<identifier>active%3AserviceAndAnother<%2Fidentifier>%0D%0A<varargs%2F>%0D%0A<%2Factive>%0D%0A<%2Fgrammar>]]>
						</xsl:attribute>
							Active URI grammar for multiple logical services with variable arguments
						</a>
					</li>
				</ul>
				<h3>Standard Grammars</h3>
				<ul>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?parse=1&identifier=1%2F2&grammar=<grammar>%0D%0A<group+name%3D"all">%0D%0A<optional>%2F<%2Foptional>%0D%0A<group+name%3D"path1">%0D%0A<regex+type%3D"alphanum"%2F>%0D%0A<%2Fgroup>%0D%0A%2F%0D%0A<group+name%3D"path2">%0D%0A<regex+type%3D"alphanum"%2F>%0D%0A<%2Fgroup>%0D%0A<%2Fgroup>%0D%0A<%2Fgrammar>]]>
						</xsl:attribute>
							Simple REST path grammar
						</a>
					</li>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?parse=1&identifier=active%3Abase%2Barg%40file%3A%2Fhome%2Fpjr%2Ftest.txt&grammar=<grammar>%0D%0A<group>%0D%0Aactive%3A%0D%0A<group+name%3D"type"><regex+type%3D"alphanum"%2F><%2Fgroup>%0D%0A%2Barg%40<group+name%3D"arg"><regex+type%3D"active-escaped-uri"%2F><%2Fgroup>%0D%0A<%2Fgroup>%0D%0A<%2Fgrammar>]]>
						</xsl:attribute>
							Simple active URI grammar
						</a>
					</li>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?parse=1&identifier=res%3A%2Fone%2F100%2Fanything!&grammar=<grammar>%0D%0A<group>%0D%0Ares%3A%2F%0D%0A<group+name%3D"path"><regex>(must|be|one|of|these)<%2Fregex><%2Fgroup>%0D%0A%2F%0D%0A<group+name%3D"number"><regex+type%3D"integer"%2F><%2Fgroup>%0D%0A%2F%0D%0A<group+name%3D"resource"><regex+type%3D"anything"%2F><%2Fgroup>%0D%0A<%2Fgroup>%0D%0A<%2Fgrammar>]]>
						</xsl:attribute>
							Restful resource path with integer field.
						</a>
					</li>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?parse=1&identifier=res%3A%2Fone%2Floose%2Fanything!&grammar=<grammar>%0D%0A<group>%0D%0Ares%3A%2F%0D%0A<group+name%3D"path"><regex>(must|be|one|of|these)<%2Fregex><%2Fgroup>%0D%0A%2F%0D%0A<group+name%3D"number"><regex+type%3D"alphanum"%2F><%2Fgroup>%0D%0A%2F%0D%0A<group+name%3D"resource"><regex+type%3D"anything"%2F><%2Fgroup>%0D%0A<%2Fgroup>%0D%0A<%2Fgrammar>]]>
						</xsl:attribute>
							Restful resource path with strict first path and looser following paths.
						</a>
					</li>
					<li>
						<a>
						<xsl:attribute name="href">
							<![CDATA[?parse=1&identifier=1%2F2%2F3%2F4%2F5%2F6&grammar=<grammar>%0D%0A<group+name%3D"all">%0D%0A<group+max%3D"*"+min%3D"1">%0D%0A<optional>%2F<%2Foptional>%0D%0A<group+name%3D"path">%0D%0A<regex+type%3D"alphanum"%2F>%0D%0A<%2Fgroup>%0D%0A<%2Fgroup>%0D%0A<%2Fgroup>%0D%0A<%2Fgrammar>]]>
						</xsl:attribute>
							Repeated simple REST path.
						</a>
					</li>
					
				</ul>
		</div>
	</xsl:template>
	
</xsl:stylesheet>
